#include <math.h>
#include <string.h>
#include <time.h>
#include <allegro.h>

#include "Data.h"

volatile unsigned int timeCount = 0;

// timer interrupt handler
void inc_timeCount()
{
	timeCount++;
}
END_OF_FUNCTION(inc_timeCount);
/*
void checkPit(int* pit, int PIT_WIDTH, int PIT_HEIGHT)
{
	int bFall;
	
	int i;
	int j;
	int k;
	
	int currGem;
	int nextGem;
	int tempGem;
	int sameCount;
	
	//Collapse vertically seems to be broken.
	
	//Check Horizontals
	for(j=0;j<PIT_HEIGHT;j++)
	{
		currGem = pit[(j * PIT_WIDTH)];
		if ((currGem >= 32) && (currGem != 255))
		{
			currGem -= 32;
		}
		
		if (pit[(j * PIT_WIDTH)] == 255)
		{
			currGem = 255;
			sameCount = 0;
		}
		else
		{
			sameCount = 1;
		}
		
		for(i=1;i<PIT_WIDTH;i++)
		{
			if (pit[(j * PIT_WIDTH) + i] != 255)
			{
				nextGem = pit[(j * PIT_WIDTH) + i];
				if ((nextGem >= 32) && (nextGem != 255))
				{
					nextGem -= 32;
				}

				if (currGem == nextGem)
				{

					sameCount++;
				}
				else
				{
					if (sameCount >= 3)
					{
						for(k=i - sameCount + 1;k<=i;k++)
						{
							tempGem = pit[(j * PIT_WIDTH) + k];
							
							if (tempGem < 32)
							{
								tempGem += 32;
								pit[(j * PIT_WIDTH) + k] = tempGem;
							}
						}
					}
					sameCount = 1;
				}
				currGem = nextGem;
			}
			else
			{
				if (sameCount >= 3)
				{
					for(k=i - sameCount;k<i;k++)
					{
						tempGem = pit[(j * PIT_WIDTH) + k];

						if (tempGem < 32)
						{
							tempGem += 32;
							pit[(j * PIT_WIDTH) + k] = tempGem;
						}
					}
				}
				sameCount = 0;
				currGem = 255;
			}

		}
		
		if (sameCount >= 3)
		{
			for(k=PIT_WIDTH - sameCount ;k<=PIT_WIDTH;k++)
			{
				tempGem = pit[(j * PIT_WIDTH) + k];
				if (tempGem < 32)
				{
					tempGem += 32;
					pit[(j * PIT_WIDTH) + k] = tempGem;
				}
			}
		}
	}
	
	// Verticals
	for(i=0;i<PIT_WIDTH;i++)
	{
		currGem = pit[i];
		if ((currGem >= 32) && (currGem != 255))
		{
			currGem -= 32;
		}

		if (pit[i] == 255)
		{
			currGem = 255;
			sameCount = 0;
		}
		else
		{
			sameCount = 1;
		}

		for(j=0;j<PIT_HEIGHT;j++)
		{
			if (pit[(j * PIT_WIDTH) + i] != 255)
			{
				nextGem = pit[(j * PIT_WIDTH) + i];
				if ((nextGem >= 32) && (nextGem != 255))
				{
					nextGem -= 32;
				}

				if (currGem == nextGem)
				{
					sameCount++;
				}
				else
				{
					if (sameCount >= 3)
					{
						for(k=j - sameCount + 1;k<=j;k++)
						{
							tempGem = pit[(k * PIT_WIDTH) + i];
							if (tempGem < 32)
							{
								tempGem += 32;
								pit[(k * PIT_WIDTH) + i] = tempGem;
							}
						}
					}
					sameCount = 1;
				}
				currGem = nextGem;
			}
			else
			{
				if (sameCount >= 3)
				{
					for(k=j - sameCount;k<j;k++)
					{
						tempGem = pit[(k * PIT_WIDTH) + i];
						if (tempGem < 32)
						{
							tempGem += 32;
							pit[(k * PIT_WIDTH) + i] = tempGem;
						}
					}
				}
				
				currGem = 255;
				sameCount = 0;
			}
		}
		
		if (sameCount >= 3)
		{
			for(k=PIT_HEIGHT - sameCount;k<PIT_HEIGHT;k++)
			{
				tempGem = pit[(k * PIT_WIDTH) + i];
				if (tempGem < 32)
				{
					tempGem += 32;
					pit[(k * PIT_WIDTH) + i] = tempGem;
				}
			}
		}
	}
	// Save Diagonals for a bit, I want to see if this works.
	
	
	// Collapse the pit instantenously
    for(i=0;i<PIT_WIDTH;i++)
    {
        j = PIT_HEIGHT - 1;
        do
        {
            currGem = pit[(j * PIT_WIDTH) + i];
            if ((currGem != 255) && (currGem >= 32))
            {
				for(k=j;k>0;k--)
				{
                    pit[(k * PIT_WIDTH) + i] = pit[((k - 1) * PIT_WIDTH) + i];
                }
                pit[i] = 255;
			}
            else
            {
                j--;
			}
        }
		while (j >= 0);
    }
}
*/
void checkPit(int* pit, int PIT_WIDTH, int PIT_HEIGHT)
{
    int i;
	int j;
	int k;

	int currGem;
	int currGem2;
	int nextGem;

	int startRange;
	int endRange;
	
    //Check Horizontals
    for(j = 0;j<PIT_HEIGHT;j++)
    {
        //Get the first gem
        i = 0;
        currGem = pit[(j * PIT_WIDTH) + i];
        if (currGem != 255)
        {
            if (currGem >= 32)
			{
                currGem2 = currGem;
                currGem = currGem - 32;
			}
            else
            {
                currGem2 = currGem + 32;
			}
		}
        else
        {
            currGem2 = currGem;
        }
        
        while (i < PIT_WIDTH)
        {
            if (currGem == 255)
            {
                i++;
                if (i < PIT_WIDTH) 
                {
                    currGem = pit[(j * PIT_WIDTH) + i];
                    if (currGem != 255)
                    {
                        if (currGem >= 32) 
                        {
                            currGem2 = currGem;
                            currGem = currGem - 32;
						}
						else
						{
                            currGem2 = currGem + 32;
						}
					}
					else
					{
                        currGem2 = currGem;
					}
                }
			}
			else
			{
                if (i < PIT_WIDTH - 1) 
                {
                    endRange = i;
                    startRange = i;
                    nextGem = pit[(j * PIT_WIDTH) + i + 1];
                    while ((currGem == nextGem) || (currGem2 == nextGem))
                    {
                        if (i + 1 < PIT_WIDTH)
                        {
                            i++;
                            endRange = i;
						}
						else
						{
                            endRange = i;
                            break;
						}

                        if (i < PIT_WIDTH) 
                        {
                            nextGem = pit[(j * PIT_WIDTH) + i + 1];
						}
						else
						{
                            break;
						}
					}

                    if (endRange - startRange + 1 >= 3)
					{
                        //Mark them
                        for(k=startRange;k<=endRange;k++)
                        {
                            pit[(j * PIT_WIDTH) + k] = currGem2;
						}
                    }

                    i++;
                }
                else
                {
                    break;
                }

                if (i < PIT_WIDTH)
                {
                    currGem = pit[(j * PIT_WIDTH) + i];
                    if (currGem != 255)
                    {
                        if (currGem >= 32) 
                        {
                            currGem2 = currGem;
                            currGem = currGem - 32;
						}
						else
						{
                            currGem2 = currGem + 32;
						}
                    }
                    else
                    {
                        currGem2 = currGem;
                    }
                }
			}
        }
    }

    //Check Verticals
    for(i = 0;i<PIT_WIDTH;i++)
    {
        //Get the first gem
        j = 0;
        currGem = pit[(j * PIT_WIDTH) + i];
        if (currGem != 255)
        {
            if (currGem >= 32) 
            {
                currGem2 = currGem;
                currGem = currGem - 32;
			}
            else
            {
                currGem2 = currGem + 32;
            }
		}
		else
		{
            currGem2 = currGem;
        }
        
        while (j < PIT_HEIGHT)
        {
            if (currGem == 255)
            {
                j++;
                if (j < PIT_HEIGHT) 
                {
                    currGem = pit[(j * PIT_WIDTH) + i];
                    if (currGem != 255)
                    {
                        if (currGem >= 32)
                        {
                            currGem2 = currGem;
                            currGem = currGem - 32;
						}
                        else
                        {
                            currGem2 = currGem + 32;
                        }
					}
					else
					{
                        currGem2 = currGem;
                    }
                }
			}
			else
			{
                if (j < PIT_HEIGHT - 1) 
                {
                    endRange = j;
                    startRange = j;
                    nextGem = pit[((j + 1) * PIT_WIDTH) + i];
                    while ((currGem == nextGem) || (currGem2 == nextGem))
                    {
                        if (j + 1 < PIT_HEIGHT) 
                        {
                            j++;
                            endRange = j;
                        }
						else
                        {
                            endRange = j;
                            break;
                        }

                        if (j < PIT_HEIGHT) 
                        {
                            nextGem = pit[((j + 1) * PIT_WIDTH) + i];
						}
						else
						{
							break;
                        }
                    }

                    if (endRange - startRange + 1 >= 3)
                    {
                        //Mark them
						for(k=startRange;k<=endRange;k++)
						{
                            pit[(k * PIT_WIDTH) + i] = currGem2;
						}
                    }

                    j++;

                }
				else
				{
                    break;
                }

                if (j < PIT_HEIGHT) 
                {
                    currGem = pit[(j * PIT_WIDTH) + i];
                    if (currGem != 255)
                    {
                        if (currGem >= 32) 
                        {
                            currGem2 = currGem;
                            currGem = currGem - 32;
						}
                        else
                        {
                            currGem2 = currGem + 32;
                        }
					}
					else
					{
                        currGem2 = currGem;
                    }
                }
            }
        }
    }
    
	// Save Diagonals for a bit, I want to see if this works.


	// Collapse the pit instantenously
    for(i=0;i<PIT_WIDTH;i++)
    {
        j = PIT_HEIGHT - 1;
        do
        {
            currGem = pit[(j * PIT_WIDTH) + i];
            if ((currGem != 255) && (currGem >= 32))
            {
				for(k=j;k>0;k--)
				{
                    pit[(k * PIT_WIDTH) + i] = pit[((k - 1) * PIT_WIDTH) + i];
                }
                pit[i] = 255;
			}
            else
            {
                j--;
			}
        }
		while (j >= 0);
    }
}

void clearPit(int* pit, int PIT_WIDTH, int PIT_HEIGHT, int GEM_COUNT)
{
	int i;
	int j;
	
	//Clear the pit
	for (j=0;j<PIT_HEIGHT;j++)
	{
		for(i=0;i<PIT_WIDTH;i++)
		{
			pit[(j * PIT_WIDTH) + i] = 255;
		}
	}

}

void drawPlasma(BITMAP* buffer, int iPalOffset, int* colorPal, int colorCount, int SCREEN_WIDTH, int SCREEN_HEIGHT, float* sinTable)
{
	int i;
	int j;
	int k;
	int iMaxX;

	float jSin;
	float kSin;

	unsigned int bufferOffs;
	
	iMaxX = SCREEN_WIDTH;
	k = 0;
	kSin = sinTable[k];
	
	for(j=0;j<SCREEN_HEIGHT;j++)
	{
		jSin = sinTable[(j + iPalOffset + 256) % colorCount];
		
		for(i=0;i<iMaxX;i++)
		{
			((short *)buffer->line[j])[i] =colorPal[(int) (fabs(sinTable[(i + iPalOffset) % colorCount] + jSin + kSin) * (float) (colorCount/3))];
			//colorPal[(int)((sinTable[(i + iPalOffset) % colorCount] * sinTable[(j + jOffs) % colorCount]) * (float)(colorCount))];
			//colorPal[(i + iPalOffset) % colorCount];
			k = ((k + 1) % colorCount);
			kSin = sinTable[k];
		}
	}

}

void initSin(float* sinTable, int NUM_VALUES)
{

	const float PI = 3.14159;
	
	int i = 0;
	
	//I want 0 to 2 PI mapped to 0 to NUM_VALUES - 1
	for (i=0;i<NUM_VALUES;i++)
	{
		sinTable[i] = sin((((float) i) * 2.0 * PI)/((float)NUM_VALUES));
	}
}
	

void initColors(int colorCount, int* colors)
{
	int i = 0;
	int iColorNum = 0;
	int iColorStep = 0;
	int iNumColors = 0;
	
	// Red Orange Yellow Green Blue Violet
	iNumColors = colorCount / 12;
	
	// Red
	iColorNum = 0;
	iColorStep =(int)(256/iNumColors);
	for(i=0;i< iNumColors;i++)
	{
		// Red - Increase
		colors[i] = makecol(iColorNum, 0, 0);
		iColorNum += iColorStep;
		if (iColorNum > 255)
		    iColorNum = 255;
	}

	for(i=iNumColors;i < iNumColors * 2;i++)
	{
		// Red - Decrease
		colors[i] = makecol(iColorNum, 0, 0);
		iColorNum -= iColorStep;
		if (iColorNum < 0)
			iColorNum = 0;
	}
	
	iColorNum = 0;
	//Orange
	for(i=iNumColors * 2;i< iNumColors * 3;i++)
	{
		// Orange - Increase
		colors[i] = makecol(iColorNum, iColorNum / 2, 0);
		iColorNum += iColorStep;
		if (iColorNum > 255)
		    iColorNum = 255;
	}

	for(i=iNumColors * 3;i < iNumColors * 4;i++)
	{
		// Orange - Decrease
		colors[i] = makecol(iColorNum, iColorNum / 2, 0);
		iColorNum -= iColorStep;
		if (iColorNum < 0)
			iColorNum = 0;
	}

	iColorNum = 0;

	//Yellow
	for(i=iNumColors * 4;i< iNumColors * 5;i++)
	{
		// Yellow - Increase
		colors[i] = makecol(iColorNum, iColorNum, 0);
		iColorNum += iColorStep;
		if (iColorNum > 255)
		    iColorNum = 255;
	}

	for(i=iNumColors * 5;i < iNumColors * 6;i++)
	{
		// Yellow - Decrease
		colors[i] = makecol(iColorNum, iColorNum, 0);
		iColorNum -= iColorStep;
		if (iColorNum < 0)
			iColorNum = 0;
	}

	iColorNum = 0;

	//Green
	for(i=iNumColors * 6;i< iNumColors * 7;i++)
	{
		// Green - Increase
		colors[i] = makecol(0, iColorNum, 0);
		iColorNum += iColorStep;
		if (iColorNum > 255)
		    iColorNum = 255;
	}
	
	for(i=iNumColors * 7;i < iNumColors * 8;i++)
	{
		// Green - Decrease
		colors[i] = makecol(0, iColorNum, 0);
		iColorNum -= iColorStep;
		if (iColorNum < 0)
			iColorNum = 0;
	}
	
	iColorNum = 0;

	//Blue
	for(i=iNumColors * 8;i< iNumColors * 9;i++)
	{
		// Blue - Increase
		colors[i] = makecol(0, 0, iColorNum);
		iColorNum += iColorStep;
		if (iColorNum > 255)
		    iColorNum = 255;
	}
	
	for(i=iNumColors * 9;i < iNumColors * 10;i++)
	{
		// Blue - Decrease
		colors[i] = makecol(0, 0, iColorNum);
		iColorNum -= iColorStep;
		if (iColorNum < 0)
			iColorNum = 0;
	}
	
	iColorNum = 0;

	//Violet
	for(i=iNumColors * 10;i< iNumColors * 11;i++)
	{
		// Violet - Increase
		colors[i] = makecol(iColorNum, 0, iColorNum);
		iColorNum += iColorStep;
		if (iColorNum > 255)
		    iColorNum = 255;
	}

	for(i=iNumColors * 11;i < iNumColors * 12;i++)
	{
		// Violet - Decrease
		colors[i] = makecol(iColorNum, 0, iColorNum);
		iColorNum -= iColorStep;
		if (iColorNum < 0)
			iColorNum = 0;
	}
}

void nextPiece(int* current, int* next, int NUM_GEMS, int* pieceX, int* pieceY, int PIT_WIDTH)
{
	current[0] = next[0];
	current[1] = next[1];
	current[2] = next[2];
	
	next[0] = (rand() % NUM_GEMS);
	next[1] = (rand() % NUM_GEMS);
	next[2] = (rand() % NUM_GEMS);
	
	(*pieceX) = (PIT_WIDTH / 2);
	(*pieceY) = -3;
}

void rotateDown(int* current)
{
	int tmp;
	
	tmp = current[2];
	current[2] = current[1];
	current[1] = current[0];
	current[0] = tmp;
}

void rotateUp(int* current)
{
	int tmp;
	
	tmp = current[0];
	current[0] = current[1];
	current[1] = current[2];
	current[2] = tmp;
}

int main(int argc, char** argv)
{

	const int GAME_NEW_LEVEL = 0;
	const int GAME_PAUSE = 1;
	const int GAME_PLAY = 2;
	const int GAME_OVER = 3;
	const int GAME_TITLE = 4;
	const int GAME_LEVEL_COMPLETE = 5;
	const int COLOR_COUNT = 512;
	
	const int SCREEN_WIDTH = 640;
	const int SCREEN_HEIGHT = 480;
	const int COLOR_DEPTH = 16;
	
	const int MIN_TICKS = 10;
	const int NUM_GEMS = 8;
	
	const int PIT_WIDTH = 9;
	const int PIT_HEIGHT = 13;
	const int PIT_OFFS_X = 176;
	const int PIT_OFFS_Y = 32;
	
	const int GEM_WIDTH = 32;
	const int GEM_HEIGHT = 32;
	
	
	const int NEXT_OFFS_X = 535;
	const int NEXT_OFFS_Y = 232;
	const int MAX_MOVE_WAIT = 30;
	const int MAX_MOVE_LEFT_RIGHT_WAIT = 6;
	
	bool bDropPiece = false;
	bool bMoveOK = false;
	
	bool releaseKeyP = true;    //need some stupid key debouncing
	bool releaseKeyESC = true;  //need some stupid key debouncing
	bool releaseKeyEnter = true;  //need some stupid key debouncing
	bool releaseKeyRotate = true; //need some stupid key debouncing
	bool releaseKeyDrop = true;   //need some stupid key debouncing
	bool bFullScreen = true;
	bool bQuit = false;
	
	BITMAP* backgroundGraph;
	BITMAP* buffer;
	BITMAP* gemGraph[NUM_GEMS];
	BITMAP* gameOverGraph = NULL;
	BITMAP* levelCompleteGraph = NULL;
	BITMAP* pauseGraph = NULL;
	BITMAP* titleGraph = NULL;
	
	DATAFILE* dataFile = NULL;

	float sinTable[COLOR_COUNT];
	
	int colorPal[COLOR_COUNT];
	int iPalOffset = 0;
	int gameState = GAME_TITLE;
	int i;
	int iDropY;
	int idx;
	int iMoveWait = 0;
	int iMoveLeftRightWait = 0;
	int x;
	int y;
	
	int pieceX;
	int pieceY;
	
	int current[3];
	int next[3];
	int pit[PIT_HEIGHT * PIT_WIDTH];
	
	unsigned int prevTime;
	
	for (i=0;i<argc;++i)
	{
		if (strcmp("win", argv[i])==0)
		{
			bFullScreen = false;
			break;
		}
	}

	// Initialize Allegro.
	allegro_init();
	install_timer();
	install_keyboard();
	
	set_color_depth(16);
	request_refresh_rate(85);
	
	if (bFullScreen)
	{
		if (set_gfx_mode(GFX_AUTODETECT, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0) != 0)
		{
			set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
			allegro_message("Couldn't set %dx%dx%d video mode.\n%s\n", SCREEN_WIDTH, SCREEN_HEIGHT, COLOR_DEPTH, allegro_error);
			return 1;
		}
	}
	else
	{
		if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0) != 0)
		{
			set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
			allegro_message("Couldn't set %dx%dx%d video mode.\n%s\n", SCREEN_WIDTH, SCREEN_HEIGHT, COLOR_DEPTH, allegro_error);
			return 1;
		}
	}
	
	buffer = create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT);
	if (buffer == NULL)
	{
		set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
		allegro_message("Error creating double buffer\n");
		return 1;
	}
	
	dataFile = load_datafile("GameData.dat");
	if (dataFile == NULL)
	{
		set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
		allegro_message("Unable to load the data file\n");
		return 1;
	}

	backgroundGraph = (BITMAP*) dataFile[BMP_BACKGROUND].dat;
	gameOverGraph = (BITMAP*) dataFile[BMP_GAMEOVER].dat;
	levelCompleteGraph = (BITMAP*) dataFile[BMP_LEVELCOMPLETE].dat;
	pauseGraph = (BITMAP*) dataFile[BMP_PAUSE].dat;
	titleGraph = (BITMAP*) dataFile[BMP_TITLE].dat;
	gemGraph[0] = (BITMAP*) dataFile[BMP_GEM0].dat;
	gemGraph[1] = (BITMAP*) dataFile[BMP_GEM1].dat;
	gemGraph[2] = (BITMAP*) dataFile[BMP_GEM2].dat;
	gemGraph[3] = (BITMAP*) dataFile[BMP_GEM3].dat;
	gemGraph[4] = (BITMAP*) dataFile[BMP_GEM4].dat;
	gemGraph[5] = (BITMAP*) dataFile[BMP_GEM5].dat;
	gemGraph[6] = (BITMAP*) dataFile[BMP_GEM6].dat;
	gemGraph[7] = (BITMAP*) dataFile[BMP_GEM7].dat;
	
	initSin(sinTable, COLOR_COUNT);
	initColors(COLOR_COUNT, colorPal);
	
	LOCK_VARIABLE(timeCount);
	LOCK_FUNCTION(inc_timeCount);
	install_int(inc_timeCount, MIN_TICKS);
	
	srand((unsigned)time(NULL));
	
	while (!bQuit)
	{
		if (gameState == GAME_TITLE)
		{

			if (timeCount != prevTime)
			{
				iPalOffset++;
				if (iPalOffset >= COLOR_COUNT)
				{
					iPalOffset = 0;
				}
				clear_to_color(buffer, makecol(255, 255, 255));
				drawPlasma(buffer, iPalOffset, colorPal, COLOR_COUNT, SCREEN_WIDTH, SCREEN_HEIGHT, sinTable);

				// Draw the Title Sprite
				x = (SCREEN_WIDTH - titleGraph->w) / 2;
				y = (SCREEN_HEIGHT - titleGraph->h) / 2;
				draw_sprite(buffer, titleGraph, x, y);
				
				prevTime = timeCount;
			}
		}
		else if (gameState == GAME_NEW_LEVEL)
		{
		}
		
		if ((gameState == GAME_PLAY) || (gameState == GAME_PAUSE) ||
			(gameState == GAME_OVER) || (gameState == GAME_LEVEL_COMPLETE))
		{
			if (timeCount != prevTime)
			{
				blit(backgroundGraph, buffer, 0, 0, 0, 0, backgroundGraph->w, backgroundGraph->h);
				if (gameState == GAME_PLAY)
				{
					// Update objects in the game
					if (iMoveWait <= 0)
					{
						bDropPiece = false;
						//Check if need to stop.
						if (pieceY >= PIT_HEIGHT - 3)
						{
							bDropPiece = true;
						}
						else if (pit[((pieceY + 3) * PIT_WIDTH) + pieceX] != 255)
						{
							bDropPiece = true;
						}
						
						if (bDropPiece)
						{
							if (pieceY >= 0)
							{
								pit[(pieceY * PIT_WIDTH) + pieceX] = current[0];
							}
							
							if (pieceY + 1 >= 0)
							{
								pit[((pieceY + 1) * PIT_WIDTH) + pieceX] = current[1];
							}
							
							if (pieceY + 2 >= 0)
							{
								pit[((pieceY + 2)* PIT_WIDTH) + pieceX] = current[2];
							}
							
							nextPiece(current, next, NUM_GEMS, &pieceX, &pieceY, PIT_WIDTH);
						}
						else
						{

							pieceY++;
						}
						checkPit(pit, PIT_WIDTH, PIT_HEIGHT);
						iMoveWait = MAX_MOVE_WAIT;
					}
					else
					{
						iMoveWait--;
					}
					
					if (iMoveLeftRightWait > 0)
					{
						iMoveLeftRightWait--;
					}
					
					// Check for Level Complete
					// Check for Game Over
					if (pit[(PIT_WIDTH / 2)]!= 255)
					{
						gameState = GAME_OVER;
					}
					
					// Fill the pit for now if playing.
					for(y=0;y<PIT_HEIGHT;y++)
					{
						for(x=0;x<PIT_WIDTH;x++)
						{
							idx = (y * PIT_WIDTH) + x;
							if (pit[idx] != 255)
							{
								draw_sprite(buffer, gemGraph[pit[idx]], PIT_OFFS_X + (x * GEM_WIDTH), PIT_OFFS_Y + (y * GEM_HEIGHT));
							}
						}
					}
					
					//draw the next piece
					draw_sprite(buffer, gemGraph[(int)next[0]], NEXT_OFFS_X, NEXT_OFFS_Y);
					draw_sprite(buffer, gemGraph[(int)next[1]], NEXT_OFFS_X, NEXT_OFFS_Y + GEM_HEIGHT);
					draw_sprite(buffer, gemGraph[(int)next[2]], NEXT_OFFS_X, NEXT_OFFS_Y + (GEM_HEIGHT * 2));
					
					//draw the current piece
					if (pieceY >= 0)
					{
						draw_sprite(buffer, gemGraph[(int)current[0]], PIT_OFFS_X + (pieceX * GEM_WIDTH), PIT_OFFS_Y + (pieceY * GEM_HEIGHT));
					}
					
					if (pieceY + 1 >= 0)
					{
						draw_sprite(buffer, gemGraph[(int)current[1]], PIT_OFFS_X + (pieceX * GEM_WIDTH), PIT_OFFS_Y + ((pieceY + 1) * GEM_HEIGHT));
					}
					
					if (pieceY + 2 >= 0)
					{
						draw_sprite(buffer, gemGraph[(int)current[2]], PIT_OFFS_X + (pieceX * GEM_WIDTH), PIT_OFFS_Y + ((pieceY + 2) * GEM_HEIGHT));
					}
					
				}
				
				// Draw Things
				
				if (gameState == GAME_PAUSE)
				{
					// Draw the Pause Sprite
					x = (SCREEN_WIDTH - pauseGraph->w) / 2;
					y = (SCREEN_HEIGHT - pauseGraph->h) / 2;
					draw_sprite(buffer, pauseGraph, x, y);
				}
				else if (gameState == GAME_OVER)
				{
					// Draw the Game Over Sprite
					x = (SCREEN_WIDTH - gameOverGraph->w) / 2;
					y = (SCREEN_HEIGHT - gameOverGraph->h) / 2;
					draw_sprite(buffer, gameOverGraph, x, y);
				}
				else if (gameState == GAME_LEVEL_COMPLETE)
				{
					// Draw the Level Complete Sprite
					x = (SCREEN_WIDTH - levelCompleteGraph->w) / 2;
					y = (SCREEN_HEIGHT - levelCompleteGraph->h) / 2;
					draw_sprite(buffer, levelCompleteGraph, x, y);
				}
				
				prevTime = timeCount;
			}
		}
		
		vsync();
		acquire_screen();
		blit(buffer, screen, 0, 0, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
		release_screen();

		if (keyboard_needs_poll())
		{
			poll_keyboard();
		}

		if (keypressed())
		{
			if ((key[KEY_Q]) || (key[KEY_ESC]))
			{
				if (releaseKeyESC)
				{
					if (gameState == GAME_TITLE)
					{
						bQuit = true;
						break;
					}
					else if (gameState == GAME_PLAY)
					{
						gameState = GAME_TITLE;
					}
					else if (gameState == GAME_PAUSE)
					{
						gameState = GAME_PLAY;
					}
					releaseKeyESC = false;
				}
			}
		}
		
		if ((key[KEY_ENTER]) || (key[KEY_SPACE]))
		{
			if (releaseKeyEnter)
			{
				if (gameState == GAME_TITLE)
				{
					clearPit(pit, PIT_WIDTH, PIT_HEIGHT, NUM_GEMS);
					//call twice to clear out old or initialize
					nextPiece(current, next, NUM_GEMS, &pieceX, &pieceY, PIT_WIDTH);
					nextPiece(current, next, NUM_GEMS, &pieceX, &pieceY, PIT_WIDTH);
					iMoveWait = MAX_MOVE_WAIT;
					iMoveLeftRightWait = MAX_MOVE_LEFT_RIGHT_WAIT;
					gameState = GAME_PLAY;
				}
				else if (gameState == GAME_OVER)
				{
					gameState = GAME_TITLE;
				}
				releaseKeyEnter = false;
			}
		}
		
		if (key[KEY_P])
		{
			if (releaseKeyP)
			{
				if (gameState == GAME_PAUSE)
				{
					gameState = GAME_PLAY;
				}
				else if (gameState == GAME_PLAY)
				{
					gameState = GAME_PAUSE;
				}
				releaseKeyP = false;
			}
		}
		
		if (!key[KEY_P])
		{
			releaseKeyP = true;
		}
		
		if ((key[KEY_Z]) || (key[KEY_UP]))
		{
			if (releaseKeyRotate)
			{
				rotateUp(current);
				releaseKeyRotate = false;
			}
		}
		else if ((key[KEY_X]) || (key[KEY_DOWN]))
		{
			if (releaseKeyRotate)
			{
				rotateDown(current);
				releaseKeyRotate = false;
			}
		}
		
		if (key[KEY_LEFT])
		{
			if (iMoveLeftRightWait <= 0)
			{
				iMoveLeftRightWait = MAX_MOVE_LEFT_RIGHT_WAIT;
				bMoveOK = true;
				if (pieceX > 0)
				{
					if (pieceY >= 0)
					{
						if (pit[(pieceY * PIT_WIDTH) + pieceX - 1] != 255)
						{
						    bMoveOK = false;
						}
					}

					if (pieceY + 1 >= 0)
					{
						if (pit[((pieceY + 1) * PIT_WIDTH) + pieceX - 1] != 255)
						{
							bMoveOK = false;
						}
					}

					if (pieceY + 2 >= 0)
					{
						if (pit[((pieceY + 2) * PIT_WIDTH) + pieceX - 1] != 255)
						{
							bMoveOK = false;
						}
					}

					if (bMoveOK)
					{
						pieceX--;
					}
				}
			}
		}
		else if (key[KEY_RIGHT])
		{
			if (iMoveLeftRightWait <= 0)
			{
				iMoveLeftRightWait = MAX_MOVE_LEFT_RIGHT_WAIT;
				if (pieceX < (PIT_WIDTH - 1))
				{
					if (pieceY >= 0)
					{
						if (pit[(pieceY * PIT_WIDTH) + pieceX + 1] != 255)
						{
						    bMoveOK = false;
						}
					}

					if (pieceY + 1 >= 0)
					{
						if (pit[((pieceY + 1) * PIT_WIDTH) + pieceX + 1] != 255)
						{
							bMoveOK = false;
						}
					}

					if (pieceY + 2 >= 0)
					{
						if (pit[((pieceY + 2) * PIT_WIDTH) + pieceX + 1] != 255)
						{
							bMoveOK = false;
						}
					}

					if (bMoveOK)
					{
						pieceX++;
					}
				}
			}
		}
		
		if (key[KEY_SPACE])
		{
			if (releaseKeyDrop)
			{
				if (gameState == GAME_PLAY)
				{
					if (pieceY >= 0)
					{
						//Drop the current piece
						iDropY = pieceY;
						while (iDropY < PIT_HEIGHT - 3) 
						{
							if (iDropY <= PIT_HEIGHT - 4)
							{
								if (pit[((iDropY + 4) * PIT_WIDTH) + pieceX] != 255)
								{
									iDropY++;
									break;
								}
							}
							iDropY++;
						}
						pieceY = iDropY; //Let the other parts of the loop do stuff.

						releaseKeyDrop = false;
					}
				}
			}
		}
		
		if ((!key[KEY_Z]) && (!key[KEY_X]) && (!key[KEY_UP]) && (!key[KEY_DOWN]))
		{
			releaseKeyRotate = true;
		}
		
		if ((!key[KEY_ESC]) && (!key[KEY_Q]))
		{
			releaseKeyESC = true;
		}
		
		if (!key[KEY_SPACE])
		{
			releaseKeyDrop = true;
		}
		
		if ((!key[KEY_ENTER]) && (!key[KEY_SPACE]))
		{
			releaseKeyEnter = true;
		}
		
		if ((!key[KEY_LEFT]) && (!key[KEY_RIGHT]))
		{
			// No need to wait if you let go of an arrow key.
            iMoveLeftRightWait = 0;
		}
	}
	
	for(i=0;i<NUM_GEMS;i++)
	{
		gemGraph[i] = NULL;
	}
	backgroundGraph = NULL;
	buffer = NULL;
	gameOverGraph = NULL;
	levelCompleteGraph = NULL;
	pauseGraph = NULL;
	titleGraph = NULL;
	
	unload_datafile(dataFile);
	
	allegro_exit();
	return 0;
}     

// Some Allegro magic to deal with WinMain().
END_OF_MAIN();
